## dask.distributed 2024.12.1+ds

=== docs/requirements.txt ===
numpydoc
tornado
toolz
cloudpickle
git+https://github.com/dask/dask
sphinx
dask-sphinx-theme>=3.0.0
# FIXME: `sphinxcontrib-*` pins are a workaround until we have sphinx>=5.
#        See https://github.com/dask/dask-sphinx-theme/issues/68.
sphinxcontrib-applehelp>=1.0.0,<1.0.7
sphinxcontrib-devhelp>=1.0.0,<1.0.6
sphinxcontrib-htmlhelp>=2.0.0,<2.0.5
sphinxcontrib-serializinghtml>=1.1.0,<1.1.10
sphinxcontrib-qthelp>=1.0.0,<1.0.7
sphinx-click
memray
sphinx_design

=== debian/changelog ===
dask.distributed (2024.12.1+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - Add support for Python 3.13 (closes: #1088286, #1090205).
  * d/patches/fall-back-to-ipv6-localhost.patch: Also ignore a
    RuntimeWarning from some tests.
  * Run dask with a matching interpreter.

 -- Colin Watson <cjwatson@debian.org>  Mon, 06 Jan 2025 15:41:14 +0000

dask.distributed (2024.5.2+ds.1-8) unstable; urgency=medium

  * Team upload.
  * Disable dask theme for now.
  * Disable test which is known not to work on single-CPU systems.
    Closes: #1087408.

 -- Santiago Vila <sanvila@debian.org>  Wed, 13 Nov 2024 00:08:00 +0100

dask.distributed (2024.5.2+ds.1-7) unstable; urgency=medium

  * Team upload
  * Correctly enable all relevant tests in manual autopkgtest script
  * Fix ignore path for autopkgtest-pkg-pybuild tests

 -- Julian Gilbey <jdg@debian.org>  Thu, 29 Aug 2024 08:53:58 +0100

dask.distributed (2024.5.2+ds.1-6) unstable; urgency=medium

  * Team upload
  * Ignore internet-requiring test files during build (missed during
    earlier successful -4 build; now using "unshare" to check)
  * Replace hand-crafted skipping script with pytest's built-in
    --last-failed option for pytest reruns
  * Improve DEP-3 patch headers

 -- Julian Gilbey <jdg@debian.org>  Wed, 28 Aug 2024 22:29:33 +0100

dask.distributed (2024.5.2+ds.1-5) unstable; urgency=medium

  * Add two more network-requiring tests to excluded tests
  * Rerun pytest on failed tests up to five time, copying approach in
    spyder, pydevd and so on
  * Reinstate 32-bit test skip patch
  * Make patch headers DEP-3 compliant

 -- Julian Gilbey <jdg@debian.org>  Tue, 27 Aug 2024 19:16:34 +0100

dask.distributed (2024.5.2+ds.1-4) unstable; urgency=medium

  * Team upload
  * Skip some tests failing on armhf/armel with jupyter-server 2.14.2
  * Set CRYPTOGRAPHY_OPENSSL_NO_LEGACY=1 for tests, otherwise they fail
  * Run all tests during build, not just distributed/tests (this also
    includes some reworking of d/rules)
  * Fix autopkgtest error code detection (cosmetic only)
  * Use unified test exclusion script, as in pydevd, and install required
    test artefacts.  This has the advantage of collecting all of the test
    exclusion information in a single place (and the
    "mark-tests-require-installation" and "override-worker-test" patches
    are consequently removed).  Also run slow tests on amd64 and arm64.
  * Fix documentation building: intersphinx links now point to local
    documentation copies
  * Move documentation to /usr/share/doc/python3-distributed as
    recommended by current Debian Policy

 -- Julian Gilbey <jdg@debian.org>  Sun, 25 Aug 2024 22:40:12 +0100

dask.distributed (2024.5.2+ds.1-3) unstable; urgency=medium

  * Team upload.
  * d/rules: skip test_fail_to_pickle_execute_1.
    This test passes except that it fails reliably on debci.  This affects
    most cpu architectures apart from arm64 and ppc64el.  This is not
    reproducible when running tests locally, preventing effectively
    addressing the root cause.
  * 32-bits.patch: new: adjust test output on 32-bit systems.
  * d/rules: skip tests timing out on riscv64 and s390x.
  * fix-version.patch: new: ensure proper version is returned.
    Thanks to Julian Gilbey (Closes: #1074795)
  * d/rules: guard against version mismatch in version.py.

 -- Étienne Mollier <emollier@debian.org>  Fri, 19 Jul 2024 21:56:00 +0200

=== debian/control ===
Source: dask.distributed
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Diane Trout <diane@ghic.org>
Section: python
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3,
               dh-sequence-sphinxdoc <!nodoc>,
               libjs-sortable-tablesort,
               pybuild-plugin-pyproject,
               python-dask-doc <!nodoc>,
               python-fsspec-doc <!nodoc>,
               python-numpy-doc <!nodoc>,
               python-pandas-doc <!nodoc>,
               python3-all,
               python3-click (>= 6.6),
               python3-cloudpickle (>= 1.5.0),
               python3-cryptography <!nocheck>,
# dask.distributed has tight version coupling with dask.  Please read
# the mail thread on debian-python@lists.debian.org[1] for more context,
# and notably [2].
# [1]: https://lists.debian.org/debian-python/2024/06/msg00047.html
# [2]: https://lists.debian.org/debian-python/2024/06/msg00051.html
               python3-dask (<< 2024.12.1.1~),
               python3-dask (>= 2024.12.1),
               python3-dask-sphinx-theme <!nodoc>,
               python3-doc <!nodoc>,
               python3-jinja2,
               python3-jupyter-server (>= 1.23.3-2) <!nocheck>,
               python3-locket,
               python3-msgpack,
               python3-numpy <!nocheck> <!nodoc>,
               python3-numpydoc <!nodoc>,
               python3-packaging,
               python3-pandas <!nocheck> <!nodoc>,
               python3-psutil,
               python3-pytest,
               python3-pytest-asyncio,
               python3-pytest-rerunfailures <!nocheck>,
               python3-pytest-timeout,
               python3-setuptools,
               python3-sortedcollections,
               python3-sphinx <!nodoc>,
               python3-sphinx-click <!nodoc>,
               python3-sphinx-design <!nodoc>,
               python3-tblib,
               python3-toolz (>= 0.8.2),
               python3-tornado (>= 5),
               python3-urllib3,
               python3-versioneer,
               python3-yaml,
               python3-zict (>= 3.0.0),
               tzdata-legacy,
               uglifyjs
Standards-Version: 4.7.0
Homepage: https://distributed.readthedocs.io/en/latest/
Vcs-Git: https://salsa.debian.org/python-team/packages/dask.distributed.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/dask.distributed
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-pybuild

Package: python3-distributed
Architecture: all
Depends: python3-dask (<< 2024.12.1.1~),
         python3-dask (>= 2024.12.1),
         ${misc:Depends},
         ${python3:Depends}
Recommends: python3-pandas,
            python3-yaml
Suggests: python-distributed-doc
Description: Dask Distributed computing for Python 3
 Dask.distributed is a lightweight library for distributed computing in
 Python. It extends both the concurrent.futures and dask APIs to
 moderate sized clusters.
 .
 This contains the Python 3 version

Package: python-distributed-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: python-dask-doc,
         python-fsspec-doc,
         python-numpy-doc,
         python-pandas-doc,
         python3-doc,
         sass-stylesheets-bulma,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Suggests: python3-distributed
Built-Using: ${sphinxdoc:Built-Using}
Description: Dask Distributed computing documentation
 Dask.distributed is a lightweight library for distributed computing in
 Python. It extends both the concurrent.futures and dask APIs to
 moderate sized clusters.
 .
 This contains the documentation
Build-Profiles: <!nodoc>

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

DEBIAN_DIR := $(CURDIR)/debian
export PYBUILD_NAME = distributed
export PYBUILD_TEST_CUSTOM = 1
export PYBUILD_TEST_ARGS = \
  cd {build_dir}; \
  $(DEBIAN_DIR)/run-tests \
    $(DEBIAN_DIR)/get-test-exclusions rules {interpreter} \
    -m pytest --pyargs distributed \
    --verbose \
    --color=no \
    --timeout-method=signal \
    --timeout=300 \
    -m "not avoid_ci"

# FIXME: several tests are tripping on the missing dask_expr raising
# FutureWarnings on dask.dataframe module import.  Setting configuration
# option "dataframe.query-planning" to False will not raise such
# warning, but the way forward would probably be to package dask_expr.
#
# Because the directory layout is different For autopkgtest-pkg-pybuild,
# we need to check the {build_dir} directory exists before trying to copy
# into it.
export PYBUILD_BEFORE_TEST = \
  mkdir -pv {home_dir}/.config \
  && printf '\173 "dataframe": \173 "query-planning": False \175 \175\n' \
     > {home_dir}/.config/dask

export NEEDED_JS=distributed/http/static/js/anime.min.js \
                 distributed/http/static/js/reconnecting-websocket.min.js

%:
	dh $@ --buildsystem=pybuild

UPSTREAM_VERSION = $(subst +ds,,$(DEB_VERSION_UPSTREAM))
execute_after_dh_testdir:
	# Guard against version mismatch in debian/patches/fix-version.patch.
	# This patch needs to be updated to newer upstream version every time.
	grep -q $(UPSTREAM_VERSION) distributed/_version.py

# This cannot be moved to debian/python3-distributed.pyinstall,
# as that happens after the tests have been run.
export PYBUILD_AFTER_BUILD = \
  cp -v distributed/tests/testegg-*-py*.egg distributed/tests/mytest.pyz \
    {build_dir}/distributed/tests

override_dh_auto_build: export http_proxy=127.0.0.1:9
override_dh_auto_build: export https_proxy=127.0.0.1:9
override_dh_auto_build:
	rm -f distributed/comm/tests/__init__.py
	set -e; \
	for p in ${NEEDED_JS}; do \
	    uglifyjs -o $$p debian/missing-sources/$${p%.min.js}.js ; \
	done
	cp /usr/share/javascript/sortable-tablesort/sortable.min.js distributed/http/static/js
	cp /usr/share/javascript/sortable-tablesort/sortable.min.css* distributed/http/static/css
	chmod a-x distributed/tests/test_utils_test.py
	dh_auto_build
	chmod a+x distributed/tests/test_utils_test.py
#	ln -s /usr/share/javascript/mathjax docs/source/_static
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	PYTHONPATH=. python3 -m sphinx -N -bhtml docs/source build/html # HTML generator
	rm -rf build/html/_static/__pycache__
endif

# This is needed for newer versions of OpenSSL
dh_auto_test: export CRYPTOGRAPHY_OPENSSL_NO_LEGACY=1

override_dh_compress:
	dh_compress -Xchangelog.html

override_dh_install:
	dh_install
	dh_installchangelogs docs/source/changelog.rst

override_dh_auto_install:
	dh_auto_install
	dh_link
	find debian/ -name *.ico -exec chmod a-x {} \;
	rm -rf debian/python3-distributed/usr/lib/python3*/dist-packages/dask-worker-space debian/python3-distributed/usr/lib/python3*/dist-packages/core debian/python3-distributed/usr/lib/python3*/dist-packages/test_cluster_dump

override_dh_installdocs:
	dh_installdocs -ppython-distributed-doc --doc-main-package=python3-distributed
	dh_installdocs --remaining-packages
	rm -vf debian/python-distributed-doc/usr/share/doc/python3-distributed/html/_static/vendor/fontawesome/*/LICENSE.txt

override_dh_auto_clean:
	touch distributed/comm/tests/__init__.py
	dh_auto_clean
	-rm $(NEEDED_JS)

=== debian/tests/control ===
Tests: pytest
Restrictions: needs-internet, flaky, allow-stderr
Depends: iputils-ping,
         python3-aiohttp,
         python3-all,
         python3-cryptography,
         python3-dill,
         python3-h5py,
         python3-ipykernel,
         python3-ipython,
# python3-ipywidgets,
         python3-joblib,
         python3-jupyter-client,
         python3-jupyter-server (>= 1.23.3-2),
# keras imports theanos which fails
#  theano/scalar/basic.py(2370)<module>() -> convert_to_bool = Cast(bool, name='convert_to_bool')
#  theano/scalar/basic.py(2323)__init__() -> self.ctor = getattr(np, o_type.dtype)
#  numpy/__init__.py(284)__getattr__() -> raise AttributeError("module {!r} has no attribute np.bool")
# python3-keras,
         python3-lz4,
         python3-matplotlib,
         python3-netcdf4,
         python3-pandas,
         python3-paramiko,
         python3-pytest,
         python3-pytest-rerunfailures,
         python3-pytest-timeout,
         python3-requests,
         python3-scipy,
         python3-sklearn,
         python3-tblib,
         tzdata-legacy,
         @

=== debian/watch ===
version=4
opts="repack,dversionmangle=s/\+ds(?:\.\d)?//,repacksuffix=+ds,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%dask.distributed-$1.tar.gz%" \
    https://github.com/dask/distributed/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
